require('camera')
robot = {}
viewport = 0
devtool = 0
moveform = 0 --0 for manual and 1 for auto

function tilestoobj()
	local x,y = 0,0
	local layer = map.layers["realworld"]
	while x < map.width do
		while y < map.height do
			if not (layer.cells[x][y] == nil) then
			_G[""..x.."&"..y.."body"] = love.physics.newBody(world, x*map.tilewidth, y*map.tileheight, "static")
			_G[""..x.."&"..y.."shape"] = love.physics.newRectangleShape(x*map.tilewidth, y*map.tileheight, map.tilewidth, map.tileheight, 0)
			_G[""..x.."&"..y.."fixture"] = love.physics.newFixture(_G[""..x.."&"..y.."body"], _G[""..x.."&"..y.."shape"], 1)
			end
			y = y + 1
		end
		x = x + 1
	end

end


function love.load()
	tidal = require 'src'

	map = assert(tidal.load('map.tmx'))
	targetset = map.tilesets["Green"]
	layer = map.layers["realworld"]
	local sx = 0
	local sy = 0
	(function ()
		while sx < map.width do
			while sy < map.height do
				if not (layer.cells[sx][sy] == nil) then
					if layer.cells[sx][sy].tileset.name == "Green" then 
						target = layer.cells[sx][sy]
						print (sx, sy)
						return
					end
				end
				sy = sy +1
			end
			sy = 0
			sx = sx + 1
		end
	end
	)()
		--[[
	target = targetset.tiles[0]
	targetquad = target.quad
	targetx, targety, targetwidth, targetheight = targetquad:getViewport()
	print (targetx, targety, targetwidth, targetheight)
	]]--
	targetx, targety = sx*map.tilewidth + (map.tilewidth/2), sy*map.tileheight + (map.tileheight/2)
	print (targetx, targety)
	scanlayer = map:newTileLayer()


	robot.x = 100
	robot.y = 100
	robot.width = 32
	robot.height = 32
	robot.scanradius = 50

	world = love.physics.newWorld(0, 0, false)

	scanshape = love.physics.newCircleShape(robot.x, robot.y, robot.scanradius)
	scanbody = love.physics.newBody(world, robot.x, robot.y, "dynamic")
	scanfixture = love.physics.newFixture(scanbody, scanshape, 1)

	charshape = love.physics.newRectangleShape(robot.width, robot.height)
	charbody = love.physics.newBody(world, robot.x, robot.y, "dynamic")
	charfixture = love.physics.newFixture(charbody, charshape, 1)

	tilestoobj()

end

function isscanned()
	local x,y = robot.x - (robot.scanradius/2), robot.y - (robot.scanradius/2)
	local layer = map.layers["realworld"]
	while x < (robot.x + robot.scanradius + robot.width) do

		while y < (robot.y + robot.scanradius + robot.height) do
			
				if not (layer.cells[math.floor(x/map.tilewidth)][math.floor(y/map.tileheight)] == nil) then
					scanlayer:setTile(math.floor(x/map.tilewidth), math.floor(y/map.tileheight), layer.cells[math.floor(x/map.tilewidth)][math.floor(y/map.tileheight)])
				end
			y = y + 20
			print("y="..y)
		end
		
		x = x + 20
		print("x="..x)
		y = robot.y - (robot.scanradius/2)
		
	end
end

function drawscanned()
	local x,y = robot.x - (robot.scanradius/2), robot.y - (robot.scanradius/2)
	local layer = map.layers["realworld"]
			love.graphics.setColor(120, 100, 25, 10)
			love.graphics.rectangle("fill", x, y, robot.scanradius + robot.width , robot.scanradius + robot.height)
end

function targetdistance()
	local xd, yd = targetx-robot.x, targety-robot.y
	local d = math.sqrt((xd*xd) + (yd*yd))
	return d
end

function movebot(side)
	local mx,my = 0,0
	local layer = map.layers["realworld"]
	if side == "up" then
		my = -1
	end
	if side == "down" then
		my = 1
	end
	if side == "left" then
		mx = -1
	end
	if side == "right" then
		mx = 1
	end

	if (layer.cells[(robot.x + sx)/map.tilewidth][(robot.y + sy)/map.tileheight] == nil) and (robot.x + sx > 0) and (robot.y + sy > 0) then
		print ("chicken")
	end

end

function movetowardtarget(dt)
	local layer = map.layers["realworld"]
	if moveform == 1 then
		--[[	if robot.x < targetx then
					if robot.y < targety then
						if (layer.cells[robot.x/map.tilewidth][(robot.y + 3)/map.tileheight] == nil) then
							robot.y = robot.y + 3
						end
					end
					if (layer.cells[(robot.x + 3)/map.tilewidth][robot.y/map.tileheight] == nil) then
						robot.x = robot.x + 3
					end
				end
			]]--



	end
end

function love.update(dt)
	isscanned()
	movetowardtarget(dt)
	if love.keyboard.isDown("up") then
		robot.y = robot.y - 1
	elseif love.keyboard.isDown("down") then
		robot.y = robot.y + 1
	elseif love.keyboard.isDown("left") then
		robot.x = robot.x - 1
	elseif love.keyboard.isDown("right") then
		robot.x = robot.x + 1
	end

	if love.keyboard.isDown("a") then
		viewport = 1
	else
		viewport = 0
	end

	if love.keyboard.isDown("d") then
		moveform = 1
	else
		moveform = 0
	end


	if love.keyboard.isDown("s") then
		devtool = 1
	else
		devtool = 0
	end

end

function love.draw()
	local layer = map.layers["realworld"]
	
		camera:set()
		camera:setPosition( robot.x - (love.graphics.getWidth()/2), robot.y - (love.graphics.getHeight()/2))
		
		local x,y = 0,0 
	--[[
		while x < map.width do
			while y < map.height do
				if not (layer.cells[x][y] == nil) then
				
					local x1,y1,x2,y2 = _G[""..x.."&"..y.."shape"]:computeAABB(0,0,0,1)
					_G[""..x.."&"..y.."poly"] = love.graphics.polygon("fill", x1, y1, x2, y2)
				end
				y = y + 1
			end
			x = x + 1
		end
	]]
	if viewport == 0 then
		map.layers["realworld"]:draw(0,0)
	elseif viewport == 1 then
		scanlayer:draw(0,0)
	end

	if devtool == 1 then
		drawscanned()
	end

	love.graphics.setColor(255, 200, 100)
		love.graphics.rectangle("fill", robot.x, robot.y, robot.width, robot.height)

		--map.layers["Back"]:draw(0,0)

		camera:unset()

end



function love.quit()

end